#!/usr/bin/env bash

GL_REGISTRY=gitlab-registry.cern.ch
GL_ROOTGROUP=atlas-itk-pixel-systemtest
GL_SUBGROUP=itk-demo-sw

GL_REGISTRY_PATH=${GL_REGISTRY}/${GL_ROOTGROUP}/${GL_SUBGROUP}

DEMI_SITE=${DEMI_SITE:-$(whoami)}
DEMI_CONTEXT=$(docker context show)
DEMI_STACK=demitools
DEMI_NET=${DEMI_NET:-deminet}
DEMI_DOCKER_DIR="$(pwd)/.docker"
DEMI_DIR=$(pwd)

COMPOSE_PROJECT_NAME=${DEMI_SITE}-${DEMI_STACK}
# profiles disabled (not supported by portainer)
# COMPOSE_PROFILES=always,traefik,management,logging

PUID=$(id -u)
PGID=$(id -g)
TZ=$(cat /etc/timezone)

# Attn: Wrong! need to derive host from Docker context!
HOST=$(hostname | xargs)
HOST_IP=$(hostname -I | awk '{print $1}')

# Service Instances
SR_IMAGE=${GL_REGISTRY_PATH}/pypi-packages/service-registry/service-registry:latest
LOKI_PORT=3100
DOZZLE_PORT=
CODESERVER_PORT=

say() {
  printf '\e[0;34m┌─ %s\n\e[0;34m└' "$1"
  printf '%.s─' $(seq 1 "$(($(tput cols) - 1))") || true
  printf '\e[0m'
}

say '.env'

cat <<-EOF | tee .env
CODESERVER_PORT=$CODESERVER_PORT
COMPOSE_PROJECT_NAME=${COMPOSE_PROJECT_NAME:-$DEMI_SITE-$DEMI_STACK}
DEMI_DIR=$DEMI_DIR
DEMI_DOCKER_DIR=$DEMI_DOCKER_DIR
DEMI_NAMESPACE=demi.${DEMI_SITE}.${DEMI_CONTEXT}.${DEMI_STACK}
DEMI_NET=$DEMI_NET
DEMI_SITE=$DEMI_SITE
DOCKER_CONTEXT=$DEMI_CONTEXT
DOZZLE_PORT=$DOZZLE_PORT
HOST=$HOST
HOST_IP=$HOST_IP
LOKI_PORT=$LOKI_PORT
PGID=$PGID
PUID=$PUID
SR_IMAGE=$SR_IMAGE
TZ=$TZ
EOF

say 'dotenv-linter'
docker run --rm -v $(pwd):/app -w /app dotenvlinter/dotenv-linter
# cat -n .env

say 'docker compose convert'
idir="instance/${COMPOSE_PROJECT_NAME}"
mkdir -p "${idir}"
cp .env $idir
docker compose convert | tee "${idir}/docker-compose.yml" >/dev/null || {
  echo "Problem in merged docker compose file!"
  exit 1
}
tree -a instance

echo "docker compose --project-directory $idir --env-file $idir/.env convert"

#---> tasks for tools
# to restart single container
# docker-compose up -d --build ${container}

# docker loging ${GL_REGISTRY}
# docker pull ${SR_IMAGE}
